// Mailmsg.cpp : implementation file
//

#include "stdafx.h"
#include "testsmtp.h"
#include "Mailmsg.h"
#include "smtpop.h"
#include "Mdisplay.h"
#include "Input.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMailmsg dialog


CMailmsg::CMailmsg(CWnd* pParent /*=NULL*/)
	: CDialog(CMailmsg::IDD, pParent)
{
	m_lhandle = 0;
	//{{AFX_DATA_INIT(CMailmsg)
	m_szDate = _T("");
	m_szFrom = _T("");
	m_szMsg = _T("");
	m_szSubject = _T("");
	m_szTo = _T("");
	//}}AFX_DATA_INIT
}


void CMailmsg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMailmsg)
	DDX_Control(pDX, IDC_LIST1, m_ListBox);
	DDX_Text(pDX, IDC_EDIT_DATE, m_szDate);
	DDX_Text(pDX, IDC_EDIT_FROM, m_szFrom);
	DDX_Text(pDX, IDC_EDIT_MSG, m_szMsg);
	DDX_Text(pDX, IDC_EDIT_SUBJECT, m_szSubject);
	DDX_Text(pDX, IDC_EDIT_TO, m_szTo);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMailmsg, CDialog)
	//{{AFX_MSG_MAP(CMailmsg)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST1, OnItemchangedList1)
	ON_NOTIFY(NM_CLICK, IDC_LIST1, OnClickList1)
	ON_BN_CLICKED(IDC_GetHeaderField, OnGetHeaderField)
	ON_BN_CLICKED(IDC_GetHeaderType, OnGetHeaderType)
	ON_BN_CLICKED(IDC_GetPartHeaders, OnGetPartHeaders)
	ON_BN_CLICKED(IDC_GetParmValue, OnGetParmValue)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMailmsg message handlers

BOOL CMailmsg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	long ll_acount, i;
	CString ls_item, ls_type;
	char fcontent[80], fname[80], msg[1025];
    HICON hIcon[2];
    int n;
    m_imageList.Create(32, 32, 0,
                       0, 2); // 32, 32 for large icons
    hIcon[0] = AfxGetApp()->LoadIcon(IDI_TEXT);
    hIcon[1] = AfxGetApp()->LoadIcon(IDI_APP);
    for (n = 0; n < 2; n++) {
      m_imageList.Add(hIcon[n]);
    }
	m_itemSelected = -1;
    m_ListBox.SetImageList(&m_imageList, LVSIL_SMALL);
	
	pop3_GetMailFrom(m_lhandle, msg, 1024, 0);
	m_szFrom = msg;
	n = pop3_GetMailTo(m_lhandle, msg, 1024, 0);
	m_szTo = msg;
	n = pop3_GetMailSubject(m_lhandle, msg, 1024, 0);
	m_szSubject = msg;
	n = pop3_GetMailDate(m_lhandle, msg, 1024, 0);
	m_szDate = msg;
	ll_acount = pop3_GetAttachCount(m_lhandle);
//	m_ListBox.SetItemCount(ll_acount+1);
//	m_ListBox.InsertItem(0,"Body Text", 0);
//	m_ListBox.SetItemData(0, 0);
	if ( ll_acount > 0 )
	{
		m_ListBox.SetItemCount(ll_acount);
		for (i=0; i < ll_acount; i++)
		{
			pop3_GetAttachedType(m_lhandle, i + 1, fcontent,
				   80, 0);
			pop3_GetAttachedName(m_lhandle, i + 1, fname,
				   80, 0);
			ls_item = fcontent;
			ls_type = ls_item.Left(ls_item.Find("/"));
			if ( ls_type.CompareNoCase("text") == 0 )
				n = 0;
			else
				n = 1;
			ls_item.Format("%s:%s",ls_type, fname);
#ifdef WIN32
			m_ListBox.InsertItem(i,ls_item, n);
			m_ListBox.SetItemData(i, n);
#else
			m_ListBox.InsertString(i, ls_item);
			m_ListBox.SetItemData(i, n);
#endif
		}
		pop3_GetAttachedName(m_lhandle, 1, fname,
				   80, 0);
		m_szMsg = "";
		if ( strlen(fname) == 0 && pop3_OpenReadBodyText(m_lhandle) == 0 )
		{
			while((n=pop3_ReadBodyText(m_lhandle, msg, 1024)) > 0 )
			{
				msg[n] = '\0';
				m_szMsg = m_szMsg + msg;
			}
		}
	}
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMailmsg::OnItemchangedList1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
    //CListCtrl* pList =
        //(CListCtrl*) GetDlgItem(IDC_LIST1);
    m_itemSelected = pNMListView->iItem;

	*pResult = 0;
}


void CMailmsg::OnClickList1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	char buffer[1024];
	int n;
	DWORD ll_image;
	// TODO: Add your control notification handler code here
    if (m_itemSelected >= 0 )
	{
		ll_image = m_ListBox.GetItemData(m_itemSelected);
		if ( ll_image == 0 )
		{
			m_szMsg = "";
		//CString strItem = m_ListBox.GetItemText(nSelected, 0);
			pop3_OpenAttached(m_lhandle, m_itemSelected+1);
			while ((n = pop3_ReadAttached(m_lhandle, buffer, 1024)) > 0 )
			{
				buffer[n] = '\0';
				m_szMsg = m_szMsg + buffer;
			}
		}
		else if ( ll_image == 1 )
		{
			CString ls_fname;
			ls_fname = m_ListBox.GetItemText( m_itemSelected, 0);
			ls_fname = ls_fname.Right(ls_fname.GetLength() - ls_fname.Find(":") - 1);
			CFileDialog fDlg(TRUE, NULL, ls_fname, 0, 
					"All Files (*.*) | *.* ||", NULL);
//ShellExecute(handle, "open", path_to_folder, NULL, NULL, SW_SHOWNORMAL);			

			if ( fDlg.DoModal() == IDOK )
			{
				ls_fname = fDlg.GetPathName();
				pop3_SaveAttachedTo(m_lhandle, m_itemSelected+1, ls_fname, 1);
			}
		}
    }
//	else if ( m_itemSelected == 0 )
//	{
//		char msg[1024];
//
//		pop3_GetMailText(m_lhandle, msg, 1024);
//		m_szMsg = msg;
//	}
	//m_itemSelected = -1;
	UpdateData(FALSE);
	*pResult = 0;
}

void CMailmsg::OnGetHeaderField() 
{
	CInput dlg;
	CMdisplay r_dlg;
	char ac_buffer[1024];
	CString sz_header;
    
	if (m_itemSelected >= 0 )
	{
		dlg.m_szShow = "Enter header name:";
		if ( dlg.DoModal() == IDOK )
		{
			sz_header = dlg.m_szInput;
			pop3_GetHeaderField(m_lhandle, m_itemSelected+1, sz_header,
				   ac_buffer, 1024, 0);
			r_dlg.m_mail = ac_buffer;
			r_dlg.DoModal();
		}
	}
}

void CMailmsg::OnGetHeaderType() 
{
	CInput dlg;
	CMdisplay r_dlg;
	char ac_buffer[1024];
	CString sz_header;
    
	if (m_itemSelected >= 0 )
	{
		dlg.m_szShow = "Enter header name:";
		if ( dlg.DoModal() == IDOK )
		{
			sz_header = dlg.m_szInput;
			pop3_GetHeaderType(m_lhandle, m_itemSelected+1, sz_header,
				   ac_buffer, 1024, 0);
			r_dlg.m_mail = ac_buffer;
			r_dlg.DoModal();
		}
	}
}

void CMailmsg::OnGetPartHeaders() 
{
	CMdisplay dlg;
	char ac_buffer[1024];

    if (m_itemSelected >= 0 )
	{
		pop3_GetPartHeaders(m_lhandle, m_itemSelected+1, ac_buffer,
					   1024, 0);
		dlg.m_mail = ac_buffer;
		dlg.DoModal();

	}
	
}

void CMailmsg::OnGetParmValue() 
{
	CInput dlg;
	CMdisplay r_dlg;
	char ac_buffer[1024];
	CString sz_header, sz_parm;
    
	if (m_itemSelected >= 0 )
	{
		dlg.m_szShow = "Enter header name:";
		if ( dlg.DoModal() == IDOK )
		{
			sz_header = dlg.m_szInput;
			dlg.m_szShow = "Enter parameter name:";
			if ( dlg.DoModal() == IDOK )
			{
				sz_parm = dlg.m_szInput;
				dlg.m_szInput = "";
				pop3_GetParmValue(m_lhandle, m_itemSelected+1, sz_header, sz_parm, 
					ac_buffer, 1024, 0);
				r_dlg.m_mail = ac_buffer;
				r_dlg.DoModal();
			}
		}
	}
	
}
