// smtpView.cpp : implementation of the CSmtpView class
//

#include "stdafx.h"
#include "testsmtp.h"
#include "ChildFrm.h"

#include "smtpDoc.h"
#include "smtpView.h"
#include "smtpop.h"
#include "msetup.h"
#include "mnumber.h"
#include "mdisplay.h"
#include "mailmsg.h"
#include "mfile.h"
#include "deftime.h"
#include "mailsheet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSmtpView

IMPLEMENT_DYNCREATE(CSmtpView, CFormView)

BEGIN_MESSAGE_MAP(CSmtpView, CFormView)
	//{{AFX_MSG_MAP(CSmtpView)
	ON_COMMAND(ID_MAIL_SEND, OnMailSend)
	ON_COMMAND(ID_MAIL_SENDMAIL, OnSendmail)
	ON_COMMAND(ID_MAIL_SETUP, OnMailSetup)
	ON_COMMAND(ID_MAIL_QUERYMAIL, OnMailQuerymail)
	ON_COMMAND(ID_MAIL_LISTMAIL, OnMailListmail)
	ON_COMMAND(ID_MAIL_RETRIEVEMAIL, OnMailRetrievemail)
	ON_COMMAND(ID_MAIL_DELETEMAIL, OnMailDeletemail)
	ON_COMMAND(ID_MAIL_OPENMAILFILE, OnMailOpenmailfile)
	ON_COMMAND(ID_EDIT_ATTACHFILE, OnEditAttachfile)
	ON_COMMAND(ID_MAIL_RETRIEVETOFILE, OnMailRetrievetofile)
	ON_COMMAND(ID_OPTIONS_TRACCEON, OnOptionsTracceon)
	ON_COMMAND(ID_OPTIONS_TRACEOFF, OnOptionsTraceoff)
	ON_COMMAND(ID_MAIL_MAILTOP, OnMailMailtop)
	ON_COMMAND(ID_MAIL_LASTMAILREAD, OnMailLastmailread)
	ON_COMMAND(ID_OPTIONS_DEFAULTTIMEOUT, OnOptionsDefaulttimeout)
	ON_COMMAND(ID_OPTIONS_PROGRESSBARON, OnOptionsProgressbaron)
	ON_COMMAND(ID_OPTIONS_PROGRESSBAROFF, OnOptionsProgressbaroff)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSmtpView construction/destruction

CSmtpView::CSmtpView()
	: CFormView(CSmtpView::IDD)
{
	//{{AFX_DATA_INIT(CSmtpView)
	m_to = _T("");
	m_subject = _T("");
	m_msg = _T("");
	m_cc = _T("");
	m_bcc = _T("");
	m_log = _T("");
	//}}AFX_DATA_INIT
	// TODO: add construction code here

	CString strSection = "Mail Address";
	CWinApp* pApp = AfxGetApp();
	m_smtphost = pApp->GetProfileString(strSection, "Smtp Host");
	m_pop3host = pApp->GetProfileString(strSection, "Pop3 Host");
	if ( m_smtphost.IsEmpty() && m_pop3host.IsEmpty() )
	{
		CMsetup dlg;
		dlg.DoModal();
	}
	smtpop_DefaultProgressBar(1); // Turn progress bar on 2/1/98
}

CSmtpView::~CSmtpView()
{
}

void CSmtpView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSmtpView)
	DDX_Control(pDX, IDC_LIST1, m_ListBox);
	DDX_Text(pDX, IDC_EDIT_TO, m_to);
	DDX_Text(pDX, IDC_EDIT_SUBJECT, m_subject);
	DDX_Text(pDX, IDC_EDIT_MSG, m_msg);
	DDX_Text(pDX, IDC_EDIT_CC, m_cc);
	DDX_Text(pDX, IDC_EDIT_BCC, m_bcc);
	DDX_Text(pDX, IDC_EDIT_LOG, m_log);
	//}}AFX_DATA_MAP
}

BOOL CSmtpView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CSmtpView printing

BOOL CSmtpView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CSmtpView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CSmtpView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CSmtpView::OnPrint(CDC* pDC, CPrintInfo*)
{
	// TODO: add code to print the controls
}

/////////////////////////////////////////////////////////////////////////////
// CSmtpView diagnostics

#ifdef _DEBUG
void CSmtpView::AssertValid() const
{
	CFormView::AssertValid();
}

void CSmtpView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CSmtpDoc* CSmtpView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSmtpDoc)));
	return (CSmtpDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSmtpView message handlers
void CSmtpView::AddLog(LPCSTR msg)
{
	int len;
	if ( (len=m_log.GetLength()) > 0 )
	{
		if ( strcmp(m_log.Right(2), "\r\n") )
			m_log = m_log + "\r\n";
	} 
	m_log = m_log + msg;
}

long CSmtpView::LogonPOP3() 
{
	long li_handle;
	char msg[512];

	CString strSection = "Mail Address";
	CWinApp* pApp = AfxGetApp();
    m_domain = pApp->GetProfileString(strSection, "Domain");
	m_smtphost = pApp->GetProfileString(strSection, "Smtp Host");
	m_smtpid = pApp->GetProfileString(strSection, "Smtp id");
	m_pop3host = pApp->GetProfileString(strSection, "Pop3 Host");
	m_pop3id = pApp->GetProfileString(strSection, "Pop3 id");
	m_pop3passwd = pApp->GetProfileString(strSection, "Pop3 passwd");

//	li_handle = pop3_NewHandle();
//	if ( li_handle > 0 )
//		pop3_Login(li_handle, m_pop3host, m_pop3id, m_pop3passwd);
	li_handle = pop3_LoginMail(m_pop3host, m_pop3id, m_pop3passwd);
	pop3_LastMsg(msg, 512);
	AddLog(msg);
	if ( li_handle <= 0 )
	{
		MessageBox(msg, "Logon Error", MB_OK );
	}

	return li_handle;
}

long CSmtpView::LogonSmtp() 
{
	long li_handle;
	char msg[512];
	CString user;

	CString strSection = "Mail Address";
	CWinApp* pApp = AfxGetApp();

    m_domain = pApp->GetProfileString(strSection, "Domain");
	m_smtphost = pApp->GetProfileString(strSection, "Smtp Host");
	m_smtpid = pApp->GetProfileString(strSection, "Smtp id");
	user = pApp->GetProfileString(strSection, "User Name");

	li_handle = smtp_LoginMail(m_smtphost, user, m_smtpid, m_domain);
	smtp_LastMsg(msg, 512);
	AddLog(msg);
	if ( li_handle <= 0 )
	{
		MessageBox(msg, "Logon Error", MB_OK );
	}

	return li_handle;
}

void CSmtpView::OnMailSend() 
{
	long li_handle, rc, nCount;
	CString ls_data;
	char msg[512];
	CTime theTime;

	BeginWaitCursor();
	UpdateData(TRUE);

	li_handle = LogonSmtp();
	if ( li_handle > 0 )
	{
		if ( (nCount = m_ListBox.GetItemCount()) > 0 )
		{
			int i, n;
			CString ls_fname;

			for ( i=0; i < nCount; i++)
			{
				ls_fname = m_ListBox.GetItemText(i, 0);
				n = m_ListBox.GetItemData(i);
				smtp_AddAttachFile(li_handle, ls_fname, n, "", n);
			}
		}
		rc = smtp_InitMail(li_handle);
		smtp_GetReply(li_handle, msg, 512);
		AddLog(msg);
		if ( rc == 0 )
		{
			rc = smtp_To(li_handle, m_to);
			smtp_GetReply(li_handle, msg, 512);
			AddLog(msg);
		}
		if ( rc == 0 && !m_cc.IsEmpty() )
		{
			rc = smtp_Cc(li_handle, m_cc);
			smtp_GetReply(li_handle, msg, 512);
			AddLog(msg);
		}
		if ( rc == 0 && !m_bcc.IsEmpty() )
		{
			rc = smtp_Bcc(li_handle, m_bcc);
			smtp_GetReply(li_handle, msg, 512);
			AddLog(msg);
		}
		if ( rc == 0 && !m_subject.IsEmpty() )
		{
			rc = smtp_Subject(li_handle, m_subject);
			smtp_GetReply(li_handle, msg, 512);
			AddLog(msg);
		}
		if ( rc == 0 )
		{
			rc = smtp_MailBodyText(li_handle, m_msg);
//			smtp_GetReply(li_handle, msg, 512);
			pop3_LastMsg(msg, 512);
			AddLog(msg);
		}
		smtp_Quit(li_handle);
		if ( rc == 0 ) 
			MessageBox( "Mail sent successful.", "Send Mail", MB_OK );
		else
			MessageBox( "Mail sent failed.", "Send Mail", MB_OK );
	}
	UpdateData(FALSE);	
	EndWaitCursor();
}

void CSmtpView::OnSendmail() 
{
	long li_handle, rc;
	int  nCount;
	char msg[512];
	CString ls_flist("");

	BeginWaitCursor();
	UpdateData(TRUE);

	li_handle = LogonSmtp();
	if ( li_handle > 0 )
	{
		smtp_GetReply(li_handle, msg, 512);
		AddLog(msg);
		if ( (nCount = m_ListBox.GetItemCount()) > 0 )
		{
			int i;
			CString ls_fname;

			for ( i=0; i < nCount; i++)
			{
				ls_fname = m_ListBox.GetItemText(i, 0);
				if ( ls_flist.IsEmpty() )
					ls_flist = ls_fname;
				else
					ls_flist = ls_flist + ", " + ls_fname;
				//n = m_ListBox.GetItemData(i);
				//smtp_AddAttachFile(li_handle, ls_fname, n, "", n);
			}
		}
		rc = smtp_SendMail(li_handle, m_to, m_cc, m_bcc, 
			m_subject, m_msg, ls_flist, 0);
//		smtp_GetReply(li_handle, msg, 512);
		smtp_LastMsg(msg, 512);
		AddLog(msg);
		smtp_Quit(li_handle);
		if ( rc == 0 ) 
			MessageBox( "Mail sent successful.", "Send Mail", MB_OK );
		else
			MessageBox( "Mail sent failed.", "Send Mail", MB_OK );

	}
	UpdateData(FALSE);
	EndWaitCursor();
}

void CSmtpView::OnMailSetup() 
{
	CMsetup dlg;

	dlg.DoModal();
	
}

void CSmtpView::OnMailQuerymail() 
{
	long li_handle;
	char msg[512];

	BeginWaitCursor();
	li_handle = LogonPOP3();
	if ( li_handle > 0 )
	{
		if (pop3_MailStatus(li_handle) >= 0 )
		{
			pop3_LastMsg(msg, 512);
			AddLog(msg);
			pop3_GetReply(li_handle, msg, 512);
			CMdisplay display_dlg;
			display_dlg.m_mail = msg;
			display_dlg.DoModal();
		}
		else
		{
			pop3_LastMsg(msg, 512);
			AddLog(msg);
		}
		pop3_Quit(li_handle);
	}
	UpdateData(FALSE);
	EndWaitCursor();
}

void CSmtpView::OnMailListmail() 
{
	long li_handle;
	char msg[512];

	BeginWaitCursor();
	li_handle = LogonPOP3();
	if ( li_handle > 0 )
	{
		if (pop3_ListMails(li_handle) > 0 )
		{
			CMdisplay display_dlg;
			pop3_LastMsg(msg, 512);
			AddLog(msg);
			pop3_GetResults(li_handle, msg, 512);
			display_dlg.m_mail = msg;
			display_dlg.DoModal();
		}
		else
		{
			//pop3_GetReply(li_handle, msg, 512);
			pop3_LastMsg(msg, 512);
			AddLog(msg);
			MessageBox( msg, "List Mail",  MB_OK );
		}
		pop3_Quit(li_handle);
	}
	UpdateData(FALSE);
	EndWaitCursor();
}

void CSmtpView::OnMailRetrievemail() 
{
	CMnumber number_dlg;
	CMailmsg display_dlg;
	long ll_handle, rc;
	char msg[4096];
	//CMailSheet *w;
	
	if ( number_dlg.DoModal() == IDOK )
	{
		BeginWaitCursor();
		if ( number_dlg.m_number >= 0 && (ll_handle = LogonPOP3()) > 0 )
		{
			//pop3_ListMails(ll_handle);
			if ((rc=pop3_RetrieveMail(ll_handle, number_dlg.m_number)) > 0 )
			{
				pop3_LastMsg(msg, 512);
				AddLog(msg);
				//pop3_GetResults(ll_handle, msg, 1024);
				//pop3_GetMailHeader(ll_handle, msg, 1024);
				display_dlg.SetPOPHandle(ll_handle);
				display_dlg.DoModal();
			}
			else if ( rc == 0 )
			{
				pop3_LastMsg(msg, 512);
				AddLog(msg);
				sprintf(msg, "No such mail number(%d)", number_dlg.m_number);
				MessageBox( msg, "Retrieve Mail",  MB_OK );
			}
			else
			{
				pop3_LastMsg(msg, 512);
				AddLog(msg);
				MessageBox( msg, "Retrieve Mail Error",  MB_OK );
			}
			pop3_Quit(ll_handle);
			pop3_LastMsg(msg, 512);
			AddLog(msg);
			UpdateData(FALSE);
		}
		EndWaitCursor();
	}
}

void CSmtpView::OnMailDeletemail() 
{
	CMnumber number_dlg;
	CMailmsg display_dlg;
	long li_handle, rc;
	char msg[4096];

	if ( number_dlg.DoModal() == IDOK )
	{
		BeginWaitCursor();
		if ( number_dlg.m_number > 0 && (li_handle = LogonPOP3()) > 0 )
		{
			rc = pop3_DeleteMail(li_handle, number_dlg.m_number);
			pop3_LastMsg(msg, 512);
//			pop3_GetReply(li_handle, msg, 512);
			AddLog(msg);
			pop3_Quit(li_handle);
			pop3_LastMsg(msg, 512);
			AddLog(msg);
			UpdateData(FALSE);
			if ( rc == 0 )
				sprintf(msg, "Delete mail # %d successful.", number_dlg.m_number);
			else
				sprintf(msg, "Delete mail # %d failed.", number_dlg.m_number);
			MessageBox( msg, "Delete Mail",  MB_OK );

		}
		EndWaitCursor();
	}	
}

void CSmtpView::OnMailOpenmailfile() 
{
	CMfile dlg;

	dlg.DoModal();
	
}

void CSmtpView::OnEditAttachfile() 
{
	int i, n;
	CString ls_filename, ls_ext;

	CFileDialog fDlg(TRUE, NULL, "*.*", 0, 
		"All Files (*.*) | *.* ||", NULL);

	if ( fDlg.DoModal() == IDOK )
	{
		ls_filename = fDlg.GetPathName();
		ls_ext = fDlg.GetFileExt();
		if ( ls_ext.CompareNoCase("txt") == 0 )
			n = 0;
		else
			n = 1;
		i = m_ListBox.GetItemCount( );
		m_ListBox.InsertItem(i,ls_filename, n);
		m_ListBox.SetItemData(i, n);
	}
	
}

void CSmtpView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
    HICON hIcon[2];
    int n;
    m_imageList.Create(32, 32, 0,
                       0, 2); // 32, 32 for large icons
    hIcon[0] = AfxGetApp()->LoadIcon(IDI_TEXT);
    hIcon[1] = AfxGetApp()->LoadIcon(IDI_APP);
    for (n = 0; n < 2; n++) {
      m_imageList.Add(hIcon[n]);
    }
    m_ListBox.SetImageList(&m_imageList, LVSIL_SMALL);

	
}

void CSmtpView::OnMailRetrievetofile() 
{
	CMnumber number_dlg;
	long ll_handle;
	CString ls_filename;

	CFileDialog fDlg(TRUE, NULL, "*.*", 0, 
		"All Files (*.*) | *.* ||", NULL);

	if ( number_dlg.DoModal() == IDOK )
	{
		if ( fDlg.DoModal() == IDOK )
		{
			ls_filename = fDlg.GetPathName();
			BeginWaitCursor();
			if ( number_dlg.m_number > 0 && (ll_handle = LogonPOP3()) > 0 )
			{
				pop3_RetrieveIntoFile(ll_handle, number_dlg.m_number, 
					 ls_filename, 1);
//				pop3_LastMsg(msg, 512);
				pop3_Quit(ll_handle);
			}
			EndWaitCursor();
		}
	}
	
}

void CSmtpView::OnOptionsTracceon() 
{
	CString ls_filename;

	CFileDialog fDlg(TRUE, NULL, "smtp.log", 0, 
		"All Files (*.*) | *.* ||", NULL);

	if ( fDlg.DoModal() == IDOK )
	{
		ls_filename = fDlg.GetPathName();
		smtp_EnableLog(ls_filename, 2);
	}
	
}

void CSmtpView::OnOptionsTraceoff() 
{
	smtp_DisableLog();
	
}

void CSmtpView::OnMailMailtop() 
{
	CMnumber number_dlg;
	CMailmsg display_dlg;
	long ll_handle, rc;
	char msg[4096];
	
	if ( number_dlg.DoModal() == IDOK )
	{
		BeginWaitCursor();
		if ( number_dlg.m_number >= 0 && (ll_handle = LogonPOP3()) > 0 )
		{
			if ((rc=pop3_QuickScanMail(ll_handle, number_dlg.m_number)) > 0 )
			{
				pop3_LastMsg(msg, 512);
				AddLog(msg);
				display_dlg.SetPOPHandle(ll_handle);
				display_dlg.DoModal();
			}
			else if ( rc == 0 )
			{
				pop3_LastMsg(msg, 512);
				AddLog(msg);
				sprintf(msg, "No such mail number(%d)", number_dlg.m_number);
				MessageBox( msg, "Retrieve Mail",  MB_OK );
			}
			else
			{
				pop3_LastMsg(msg, 512);
				AddLog(msg);
				MessageBox( msg, "Retrieve Mail Error",  MB_OK );
			}
			pop3_Quit(ll_handle);
			pop3_LastMsg(msg, 512);
			AddLog(msg);
			UpdateData(FALSE);
		}
		EndWaitCursor();
	}
}

void CSmtpView::OnMailLastmailread() 
{
	long li_handle, cc;
	char msg[512];

	BeginWaitCursor();
	li_handle = LogonPOP3();
	if ( li_handle > 0 )
	{
		if ((cc=pop3_LastMailRead(li_handle)) >= 0 )
		{
			pop3_LastMsg(msg, 512);
			AddLog(msg);
			pop3_GetReply(li_handle, msg, 512);
			CMnumber number_dlg;
			number_dlg.m_number = cc;
			number_dlg.DoModal();
		}
		else
		{
			pop3_LastMsg(msg, 512);
			AddLog(msg);
		}
		pop3_Quit(li_handle);
	}
	UpdateData(FALSE);
	EndWaitCursor();
	
}

void CSmtpView::OnOptionsDefaulttimeout() 
{
	CDefTime DefTime_dlg;
	CString msg;
	long cc;
	
	if ( DefTime_dlg.DoModal() == IDOK )
	{
		cc = smtp_DefaultTimeOut(DefTime_dlg.m_lTimeOut);
		msg.Format("Default time set to %ld from %ld", 
			DefTime_dlg.m_lTimeOut, cc);
		MessageBox( msg, "Default Time Out",  MB_OK );
	}
	
}


void CSmtpView::OnOptionsProgressbaron() 
{
	// TODO: Add your command handler code here
	smtpop_DefaultProgressBar(1);
	
}

void CSmtpView::OnOptionsProgressbaroff() 
{
	// TODO: Add your command handler code here
	smtpop_DefaultProgressBar(0);
	
}
